#pragma once

#include "Point3d.h"
#include "Face.h"
#include <vector>



class	SimpleMesh									//A general-purpose surface mesh class
{
public:
					  SimpleMesh();
				   ~SimpleMesh();
int					readPly(const char* fname);	//Read mesh from PLY file
int					readDMS(const char* fname);	//Read point cloud from DMS file
float				scaleDown();				//Normalize this in [-1..1]
void				setNormals(bool flip=false,bool area_weighting=false);
												//Compute vertex normals (using face connectivity) with or w/o area weighting
void				setApproxNormals(bool flip);//Compute approx vertex normals from nearest nbs
void				clearFaces();				//Clears all faces and sets has_vertex_normals to false, since we'll make new faces
float				signedVolume(int face_id) const;
												//Signed volume of tetrahedron with vertices origin + 3 vertices of given face of this mesh
 												//estimate vertex and average radius
 float 			estimateRadius(int nneigh, vector<float> &rads);

 												//get mass center
 void 			center(Point3d& p);

vector<Point3d>		points;
vector<face>		faces;
bool				has_vertex_normals;			//Whether the mesh has vertex normals or not (for rendering)
};
